//+------------------------------------------------------------------+
//|                                                   SuperMario.mq4 |
//|                                           Lorentzos Roussos 2016 |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Lorentzos Roussos 2016"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#include <Canvas\Canvas.mqh>
class CCanvas;
enum ground
{
ground_ma=0,//Moving Average
ground_close=1//Close
};
input ground GroundType=ground_ma;//Ground Type :
input int GroundMAPeriod=5;//Ground MA Period :
input ENUM_MA_METHOD GroundMAMethod=MODE_LWMA;//Ground MA Method :
input ENUM_APPLIED_PRICE GroundMAApplied=PRICE_TYPICAL;//Ground MA Price :
input int TopPixels=50;//Top Gap 
input ground HorizonType=ground_ma;//Ground Type :
input int HorizonMAPeriod=8;//Ground MA Period :
input ENUM_MA_METHOD HorizonMAMethod=MODE_LWMA;//Ground MA Method :
input ENUM_APPLIED_PRICE HorizonMAApplied=PRICE_TYPICAL;//Ground MA Price :


//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
long this_id;
//screen size 
int screen_x=0;
int screen_y=0;
CCanvas SkyMatrix;
CCanvas GroundMatrix;
CCanvas HorizonMatrix;
CCanvas CloudMatrix;
int cloud_sx,cloud_sy,cloud_px,cloud_py;
int OnInit()
  {
//---
  ObjectsDeleteAll(0,"SM_");
  screen_x=ChartGetInteger(0,CHART_WIDTH_IN_PIXELS);
  screen_y=ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS);
  //get chart id
  this_id=ChartID();
  //zoom in
  ChartSetInteger(this_id,CHART_SCALE,5);
  ChartSetInteger(this_id,CHART_AUTOSCROLL,false);
  ChartSetInteger(this_id,CHART_SHIFT,false);
  ChartRedraw(this_id);
  //find navigation
  int vbars=ChartGetInteger(this_id,CHART_VISIBLE_BARS,0);
  int navi=100-vbars;
int bars_start=100;
      navi=navi*(-1);
  ChartNavigate(this_id,CHART_END,navi);
  ChartSetInteger(this_id,CHART_MODE,CHART_LINE);
  ChartRedraw(this_id);
  //Create Sky Canvas
  bool created;
  cloud_sx=screen_x/0.5;
  cloud_sy=screen_y/1;
  cloud_px=0;
  cloud_py=screen_y/3;
  created=SkyMatrix.CreateBitmapLabel("SM_SkyMatrix",0,0,screen_x,screen_y,COLOR_FORMAT_ARGB_NORMALIZE);
  created=HorizonMatrix.CreateBitmapLabel("SM_HorizonMatrix",0,0,screen_x,screen_y,COLOR_FORMAT_ARGB_NORMALIZE);  
  created=CloudMatrix.CreateBitmapLabel("SM_CloudMatrix",0,0,cloud_sx,cloud_sy,COLOR_FORMAT_ARGB_NORMALIZE);  
  created=GroundMatrix.CreateBitmapLabel("SM_GroundMatrix",0,0,screen_x,screen_y,COLOR_FORMAT_ARGB_NORMALIZE);
  uint cloud_outline=ColorToARGB(clrGainsboro,85);
  uint cloud_fill=ColorToARGB(clrWhite,117);
  int radius1=cloud_sy/2;
  int radius2=cloud_sy/2.8;
  int center_y=cloud_sy/2;
  int center_x1=cloud_sx/6;
  int center_x2=center_x1*2;
  int center_x3=center_x1*3;
  CloudMatrix.Erase(0);
  CloudMatrix.FillCircle(center_x1,center_y,radius2,cloud_outline);
  CloudMatrix.FillCircle(center_x2,center_y,radius1,cloud_outline);
  CloudMatrix.FillCircle(center_x3,center_y,radius2,cloud_outline);
  radius1=radius1-3;
  radius2=radius2-1;
  CloudMatrix.FillCircle(center_x1,center_y,radius2,cloud_fill);
  CloudMatrix.FillCircle(center_x2,center_y,radius1,cloud_fill);
  CloudMatrix.FillCircle(center_x3,center_y,radius2,cloud_fill);  
  CloudMatrix.Update(true);
  
  int start_red=233;
  int start_green=233;
  int start_blue=255;
  double s_red,s_green,s_blue;
  s_red=start_red;
  s_green=start_green;
  s_blue=start_blue;
  double s_step=screen_y;
  s_step=200/s_step;
  uint sky_color;
  string or_color;
  color g_color;
  //loop y pixels top to bottom
  for(int y=0;y<screen_y;y++)
    {
    or_color=start_red+","+start_green+","+start_blue;
    g_color=StringToColor(or_color);
    sky_color=ColorToARGB(g_color,255);
     //loop to x pixels 
     for(int x=0;x<screen_x;x++)
       {
       SkyMatrix.PixelSet(x,y,sky_color);
       }
    s_red=s_red-s_step;
    s_green=s_green-s_step;
    start_red=s_red;
    start_green=s_green;
    }

    SkyMatrix.Update(true);
    //ObjectSetInteger(0,"SM_SkyMatrix",OBJPROP_BACK,true);

     redraw_ground(bars_start,vbars);
    //Create ground ends here 
  //Create Sky Canvas Ends Here 
  ChartSetInteger(this_id,CHART_MOUSE_SCROLL,false);
 
//---
   return(INIT_SUCCEEDED);
  }
//FUnction to redraw ground
  bool redraw_ground(int coord,int vb)
   {
   cloud_px+=10;
   if(cloud_px>screen_x) cloud_px=(-1)*cloud_sx;   
   ObjectSetInteger(0,"SM_CloudMatrix",OBJPROP_XDISTANCE,cloud_px);
   int shi=MathRand();
   shi=shi/3000;
   GroundMatrix.Erase(0);
   HorizonMatrix.Erase(0);
    //Create ground
    string objna;
    bool obji;
    int prx,pry;
    int nrx,nry;
    
    int bars_ent=coord-vb-2;
    bool c;
    int co=0;
    string gca="100,200,30";
    string gcb="90,190,30";
    string gcc="5,55,5";
    color gcca=StringToColor(gca);
    color gccb=StringToColor(gcb);
    color gccc=StringToColor(gcc);
    uint ground_color_a=ColorToARGB(gcca,255);
    uint ground_color_b=ColorToARGB(gccb,255);
    uint ground_color_c=ColorToARGB(gccc,255);
    uint horizon_color_a=ColorToARGB(clrBlack,35);
    uint horizon_color_b=ColorToARGB(clrBlack,35);
    if(bars_ent<1) bars_ent=1;
    double price_a,price_b;
    for(int g=coord;g>=bars_ent;g--)
     {
     if(GroundType==ground_close) 
      {
      price_a=Close[g];
      price_b=Close[g-1];
      }
     if(GroundType==ground_ma)
      {
      price_a=iMA(NULL,0,GroundMAPeriod,0,GroundMAMethod,GroundMAApplied,g);
      price_b=iMA(NULL,0,GroundMAPeriod,0,GroundMAMethod,GroundMAApplied,g-1);      
      }
     c=ChartTimePriceToXY(0,0,Time[g],price_a,prx,pry);
     c=ChartTimePriceToXY(0,0,Time[g-1],price_b,nrx,nry);
     if(pry<=TopPixels) pry=TopPixels;
     if(nry<=TopPixels) nry=TopPixels;
     GroundMatrix.FillTriangle(prx,pry,nrx,nry,prx,screen_y,ground_color_a);
     GroundMatrix.FillTriangle(nrx,nry,nrx,screen_y,prx,screen_y,ground_color_b);
     GroundMatrix.Line(prx,pry,nrx,nry,ground_color_c);
     GroundMatrix.Line(prx,pry-1,nrx,nry-1,ground_color_c);
     GroundMatrix.Line(prx,pry-2,nrx,nry-2,ground_color_c);
     GroundMatrix.Line(prx,pry-3,nrx,nry-3,ground_color_c);     
     GroundMatrix.Line(prx,pry-4,nrx,nry-4,ground_color_c);
     GroundMatrix.Line(prx,pry-5,nrx,nry-5,ground_color_c);
     GroundMatrix.Line(prx,pry-6,nrx,nry-6,ground_color_c);
     GroundMatrix.Line(prx,pry-7,nrx,nry-7,ground_color_c);
     }    
     GroundMatrix.Update(true);   

    for(int g=coord;g>=bars_ent;g--)
     {
     if(HorizonType==ground_close) 
      {
      price_a=Close[g];
      price_b=Close[g-1];
      }
     if(HorizonType==ground_ma)
      {
      price_a=iMA(NULL,0,HorizonMAPeriod,shi,HorizonMAMethod,HorizonMAApplied,g);
      price_b=iMA(NULL,0,HorizonMAPeriod,shi,GroundMAMethod,HorizonMAApplied,g-1);      
      }
     c=ChartTimePriceToXY(0,0,Time[g],price_a,prx,pry);
     c=ChartTimePriceToXY(0,0,Time[g-1],price_b,nrx,nry);
     if(pry<=TopPixels) pry=TopPixels;
     if(nry<=TopPixels) nry=TopPixels;
     HorizonMatrix.FillTriangle(prx,pry,nrx,nry,prx,screen_y,horizon_color_a);
     HorizonMatrix.FillTriangle(nrx,nry,nrx,screen_y,prx,screen_y,horizon_color_b);

     }    
     HorizonMatrix.Update(true);        
     
     
   return(true);
   }
//function to redraw ground ends here 
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
  if(id==CHARTEVENT_CHART_CHANGE)
   {
   //get visible bars 
   int vbars=ChartGetInteger(0,CHART_VISIBLE_BARS);
   int fbars=ChartGetInteger(0,CHART_FIRST_VISIBLE_BAR);
   int co=fbars;
   redraw_ground(co,vbars);
   }
  }
//+------------------------------------------------------------------+
